`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    15:46:24 01/03/06
// Design Name:    
// Module Name:    CLK_GEN
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module CLK_GEN(FPGA_CLK, FPGA_RESET, DDC_CLK_OUT, DDC_CLK_SEL, DIVXCLK_LOW_REG, DIVXCLK_HIGH_REG);
  input FPGA_CLK, FPGA_RESET;
  output DDC_CLK_OUT;

  input [2:0] DDC_CLK_SEL;
  input [3:0] DIVXCLK_LOW_REG;
  input [3:0] DIVXCLK_HIGH_REG;

  //wire div1clk; //000
/*  reg div2clk,	 //001
      div4clk,	 //010
		div8clk,  //011
		div16clk, //100
		div32clk; //101 */
	 //divXclk   //110 111

  // synthesis attribute clock_signal of divXclk is "yes";
  // synthesis attribute clock_signal of DDC_CLK_OUT is "yes";

  //assign div1clk = FPGA_CLK;
  /*  
  always @(posedge FPGA_CLK or negedge FPGA_RESET)
    begin
	 if(FPGA_RESET==1'b0) div2clk = 1'b0;
	 else div2clk = !div2clk;
    end

  always @(posedge div2clk or negedge FPGA_RESET)
    begin
	 if(FPGA_RESET==1'b0) div4clk = 1'b0;
	 else div4clk = !div4clk;
    end

  always @(posedge div4clk or negedge FPGA_RESET)
    begin
	 if(FPGA_RESET==1'b0) div8clk = 1'b0;
	 else div8clk = !div8clk;
    end

  always @(posedge div8clk or negedge FPGA_RESET)
    begin
	 if(FPGA_RESET==1'b0) div16clk = 1'b0;
	 else div16clk = !div16clk;
    end

  always @(posedge div16clk or negedge FPGA_RESET)
    begin
	 if(FPGA_RESET==1'b0) div32clk = 1'b0;
	 else div32clk = !div32clk;
    end */

/*
  wire sel1, sel2, sel4, sel8, sel16;
  //wire sel32;  //taken care of because this is the default case

  assign sel1= !DDC_CLK_SEL[2] & !DDC_CLK_SEL[1] &  !DDC_CLK_SEL[0];
  assign sel2= !DDC_CLK_SEL[2] & !DDC_CLK_SEL[1] &   DDC_CLK_SEL[0];
  assign sel4= !DDC_CLK_SEL[2] &  DDC_CLK_SEL[1] &  !DDC_CLK_SEL[0];
  assign sel8= !DDC_CLK_SEL[2] &  DDC_CLK_SEL[1] &   DDC_CLK_SEL[0];
  assign sel16= DDC_CLK_SEL[2] & !DDC_CLK_SEL[1] &  !DDC_CLK_SEL[0];
  //assign sel32= DDC_CLK_SEL[2] & !DDC_CLK_SEL[1] &   DDC_CLK_SEL[0];


  assign DDC_CLK_OUT = sel1 ? div1clk : sel2 ? div2clk : sel4 ? div4clk : sel8 ? div8clk : sel16 ? div16clk : div32clk;
*/


/*begin new code*/

reg divXclk;
reg [3:0] divXclk_count_low;
reg [3:0] divXclk_count_high;

always @(posedge FPGA_CLK or negedge FPGA_RESET)
  begin
  if(FPGA_RESET==1'b0)
    begin
	 divXclk_count_low[3:0]=4'b0000;
	 divXclk_count_high[3:0]=4'b0000;
	 divXclk=1'b0;
	 end

/*		  //this synthesizes weirdly, only to 150MHz.  Below synthesizes to 182.7 MHz
  else
    begin
	 if(divXclk==1'b0 && divXclk_count_low[3:0]!=DIVXCLK_LOW_REG[3:0])
	   begin
		divXclk=1'b0;
		divXclk_count_low[3:0] = divXclk_count_low[3:0] + 4'b0001;
		end
	 else if(divXclk==1'b0 && divXclk_count_low[3:0]==DIVXCLK_LOW_REG[3:0])
	   begin
		divXclk=1'b1;
		divXclk_count_low[3:0] = 4'b0000;
		end
	 else if(divXclk==1'b1 && divXclk_count_high[3:0]!=DIVXCLK_HIGH_REG[3:0])
	   begin
		divXclk=1'b1;
		divXclk_count_high[3:0] = divXclk_count_high[3:0] + 4'b0001;
		end
	 else	//if(divXclk==1'b1 && divXclk_count_high[3:0]==DIVXCLK_HIGH_REG[3:0])
	   begin
		divXclk=1'b0;
		divXclk_count_high[3:0] = 4'b0000;
		end
	 end
*/
/*
  else
    begin
	 if(divXclk==1'b0 && divXclk_count_low[3:0]!=4'b0000)
	   begin
		divXclk=1'b0;
		divXclk_count_low[3:0] = divXclk_count_low[3:0] - 4'b0001;
		end
	 else if(divXclk==1'b0 && divXclk_count_low[3:0]==4'b0000)
	   begin
		divXclk=1'b1;
		divXclk_count_low[3:0] = DIVXCLK_LOW_REG[3:0];
		end
	 else if(divXclk==1'b1 && divXclk_count_high[3:0]!=4'b0000)
	   begin
		divXclk=1'b1;
		divXclk_count_high[3:0] = divXclk_count_high[3:0] - 4'b0001;
		end
	 else	//if(divXclk==1'b1 && divXclk_count_high[3:0]==DIVXCLK_HIGH_REG[3:0])
	   begin
		divXclk=1'b0;
		divXclk_count_high[3:0] = DIVXCLK_HIGH_REG[3:0];
		end
	 end
*/
  else
    begin
	 if(!divXclk & |divXclk_count_low[3:0])
	   begin
		divXclk=1'b0;
		divXclk_count_low[3:0] = divXclk_count_low[3:0] - 4'b0001;
		end
	 else if(!divXclk & !(|divXclk_count_low[3:0]))
	   begin
		divXclk=1'b1;
		divXclk_count_low[3:0] = DIVXCLK_LOW_REG[3:0];
		end
	 else if(divXclk && |divXclk_count_high[3:0])
	   begin
		divXclk=1'b1;
		divXclk_count_high[3:0] = divXclk_count_high[3:0] - 4'b0001;
		end
	 else	//if(divXclk && !(|divXclk_count_high[3:0]))
	   begin
		divXclk=1'b0;
		divXclk_count_high[3:0] = DIVXCLK_HIGH_REG[3:0];
		end
	 end

  end

//assign DDC_CLK_OUT = (DDC_CLK_SEL[2:0]==3'b000) ? /*div1clk*/ FPGA_CLK : (DDC_CLK_SEL[2:0]==3'b001) ? div2clk : (DDC_CLK_SEL[2:0]==3'b010) ? div4clk : (DDC_CLK_SEL[2:0]==3'b011) ? div8clk : (DDC_CLK_SEL[2:0]==3'b100) ? div16clk : (DDC_CLK_SEL[2:0]==3'b101) ? div32clk : divXclk;

BUFGMUX GBUF_FOR_MUX_DDC_OUTPUT_CLOCK

    (.O(DDC_CLK_OUT),

     .I0(1'b0),

     .I1(divXclk),

     .S(|DDC_CLK_SEL[2:0]));



/*end new code*/

//assign DDC_CLK_OUT = (DDC_CLK_SEL[2:0]==3'b000) ? div1clk : (DDC_CLK_SEL[2:0]==3'b001) ? div2clk : (DDC_CLK_SEL[2:0]==3'b010) ? div4clk : (DDC_CLK_SEL[2:0]==3'b011) ? div8clk : (DDC_CLK_SEL[2:0]==3'b100) ? div16clk : div32clk;

endmodule